"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const _ = __importStar(require("lodash"));
const metadataInfo_1 = require("../metadataInfo");
const baseMetadataRetriever_1 = __importDefault(require("./baseMetadataRetriever"));
const metadataFiles_1 = __importDefault(require("../metadataFiles"));
const QUERY = "SELECT Id, DeveloperName, NamespacePrefix From CustomPermission";
class CustomPermissionRetriever extends baseMetadataRetriever_1.default {
    constructor(org) {
        super(org, false);
        this.org = org;
        super.setQuery(QUERY);
    }
    static getInstance(org) {
        if (!CustomPermissionRetriever.instance) {
            CustomPermissionRetriever.instance = new CustomPermissionRetriever(org);
        }
        return CustomPermissionRetriever.instance;
    }
    async getObjects() {
        if ((this.data === undefined || this.data.length == 0) &&
            !this.dataLoaded) {
            super.setQuery(QUERY);
            let customPermissions = await super.getObjects();
            for (let i = 0; i < customPermissions.length; i++) {
                let cp = customPermissions[i];
                if (!_.isNil(cp.NamespacePrefix)) {
                    cp.FullName = `${cp.NamespacePrefix}__${cp.DeveloperName}`;
                }
                else {
                    cp.FullName = cp.DeveloperName;
                }
            }
            this.data = customPermissions;
            this.dataLoaded = true;
        }
        return this.data;
    }
    async getCustomPermissions() {
        return await this.getObjects();
    }
    async customPermissionExists(customPermissionStr) {
        let found = false;
        //Look first in project files
        if (!_.isNil(metadataInfo_1.METADATA_INFO.CustomPermission.components)) {
            found = metadataInfo_1.METADATA_INFO.CustomPermission.components.includes(customPermissionStr);
        }
        if (!found && !metadataFiles_1.default.sourceOnly) {
            //not found, check on the org
            let custumPermissions = await this.getCustomPermissions();
            let foundCp = custumPermissions.find(customPermission => {
                return customPermission.FullName === customPermissionStr;
            });
            found = !_.isNil(foundCp);
        }
        return found;
    }
}
exports.default = CustomPermissionRetriever;
//# sourceMappingURL=customPermissionRetriever.js.map